<?php

require_once 'connect.php';
require_once 'inc/messages.php';

// retorna array com lista, ou false se deu erro
function tabela_preco_getAll() {
  global $conexao;
  $sql = 'select * from erpc_saldos_enderecar where st_ativo=?';
  $values[] = '1';
  $result = _prepareAndQuery($sql, $values);
  return $result;
}

// retorna array associativo com objeto, ou false se deu erro/não encontrar
function tabela_preco_getById($id) {
  global $conexao;
  $sql = 'select * from erpc_saldos_enderecar where id=? and st_ativo=1';
  $values[] = $id;
  $result = _prepareAndQuery($sql, $values);
  if ($result !== false) {
    if (count($result) === 1) {
      $result = $result[0];
      $itens = tabela_preco_item_getById($id);
      // se não tiver itens, cria um array vazio
      if ($itens === false) {
        $result = false;
        addError('Erro ao carregar os itens');
      } else {
        $result['itens'] = $itens;
        // já formato os campos aqui? por hora sim...
        foreach($result as $k => $v) {
          $result[$k] = sgcws_format_field($k, $v);
        }
      }
    } else {
      $result = false;
      addError('Id não encontrado');
    }
  }

  return $result;
}

// retorna array associativo com objeto, ou false se deu erro/não encontrar
function tabela_preco_item_getById($id_pai) {
  global $conexao;
  $sql = 'select tpi.*, p.ds_produto from erpc_saldos_enderecar_item tpi join erpc_saldos p on (p.id = tpi.id_produto) where tpi.id_tabela_preco=?';
  $values[] = $id_pai;
  $result = _prepareAndQuery($sql, $values);
  return $result;
}

// insere novo
function tabela_preco_insert($tabela_preco, &$error=null) {
  global $conexao;
  $ok = false;
  $sql = 'insert into erpc_saldos_enderecar ';
  $campos = array('id_empresa', 'id_regiao', 'ds_tabela_preco', 'dh_inicio', 'dh_fim', 'ds_pagamento', 'ds_tipo_horario', 'st_ativo');
  $values = array();
  foreach($campos as $campo) {
    $values[] = $tabela_preco[$campo];
  }
  $sql .= '(' . implode(',', $campos) . ') values (' . trim(str_repeat('?,', count($values)), ',') . ')';
  $ok = _prepareAndExecute($sql, $values, $error);
  if ($ok !== false) {
    $tabela_preco['id'] = mysqli_insert_id($conexao);
    $ok = tabela_preco_item_insert($tabela_preco, $error);
    if ($ok && $error === null) {
      addMessage('Inserido com sucesso');
    }
  }
  return $ok;
}

// insere novo item
function tabela_preco_item_insert($tabela_preco, &$error=null) {
  global $conexao;
  $ok = false;
  $itens = $tabela_preco['itens'];
  if (count($itens) > 0) {
    $sql = 'insert into erpc_saldos_enderecar_item ';
    $campos = array('id_tabela_preco', 'id_produto', 'vl_preco_venda', 'vl_desconto', 'st_ativo');
    $sql .= '(' . implode(',', $campos) . ') values ';
    $sql .= '(' . trim(str_repeat('?,', count($campos)), ',') . ')';
    $values = array();
    foreach($itens as $item) {
      if (!empty($item['id_produto'])) {
        $item['id_tabela_preco'] = $tabela_preco['id'];
        foreach($campos as $campo) {
          if (in_array($campo, ['st_ativo'])) {
            $values[] = isset($item[$campo]) ? '1' : '0';
          } else {
            $values[] = $item[$campo];
          }
        }
      }
    }
    // remove última ','
    if (empty($values)) {
      // nada para inserir
      $ok = true;
    } else {
      $ok = _prepareAndExecute($sql, $values, $error, true);
    }
  } else {
    // nada para inserir
    $ok = true;
  }
  return $ok;
}

// atualiza o objeto passado no bd
function tabela_preco_update($tabela_preco) {
  global $conexao;
  $ok = false;
  $sql = 'update erpc_saldos_enderecar set ';
  $campos = array('id_empresa', 'id_regiao', 'ds_tabela_preco', 'dh_inicio', 'dh_fim', 'ds_pagamento', 'ds_tipo_horario', 'st_ativo');
  $values = array();
  foreach($campos as $campo) {
    $sql .= $campo . '=?,';
    $values[] = $tabela_preco[$campo];
  }
  $sql = trim($sql, ',');
  $sql .= ' where id = ?';
  $values[] = $tabela_preco['id'];
  $ok = _prepareAndExecute($sql, $values);
  if ($ok !== false) {
    $ok = tabela_preco_item_update($tabela_preco);
    if ($ok !== false) {
      addMessage('Atualizado com sucesso');
    }
  }
  return $ok;
}

// atualiza os itens do objeto passado no bd, apaga tudo e insere de novo
function tabela_preco_item_update($tabela_preco) {
  global $conexao;
  $ok = false;
  $sql = 'delete from erpc_saldos_enderecar_item where id_tabela_preco=?';
  $values = array($tabela_preco['id']);
  $ok = _prepareAndExecute($sql, $values);
  if ($ok !== false) {
    $ok = tabela_preco_item_insert($tabela_preco);
  }
  return $ok;
}

function tabela_preco_delete($tabela_preco) {
  global $conexao;
  $ok = false;
  $sql = 'update erpc_saldos_enderecar set st_ativo = 0';
  $values = array();
  $sql .= ' where id = ?';
  $values[] = $tabela_preco['id'];
  $ok = _prepareAndExecute($sql, $values);
  if ($ok) {
    $ok = tabela_preco_item_delete($tabela_preco);
  }
  if ($ok !== false) {
    addMessage('Removido com sucesso');
  }
  return $ok;
}

function tabela_preco_item_delete($tabela_preco) {
  global $conexao;
  $ok = false;
  $sql = 'update erpc_saldos_enderecar_item set st_ativo = 0 where id_tabela_preco=?';
  $values = array($tabela_preco['id']);
  $ok = _prepareAndExecute($sql, $values);
  return $ok;
}

function tabela_preco_create() {
  $tabela_preco = array(
    'id' => '',
    'id_empresa' => '',
    'id_regiao' => '',
    'ds_tabela_preco' => '',
    'dh_inicio' => '',
    'dh_fim' => '',
    'ds_pagamento' => '',
    'ds_tipo_horario' => '',
    'st_ativo' => '1',
    'itens' => array(),
  );
  return $tabela_preco;
}

function tabela_preco_item_create() {
  $tabela_preco = array(
    'id_tabela_preco' => '',
    'id_produto' => '',
    'vl_preco_venda' => '',
    'vl_desconto' => '',
    'st_ativo' => '1',
    'ds_produto' => '',
  );
  return $tabela_preco;
}
